#!/usr/bin/env ruby
#
#== TITLE
TITLE = "̿ HTML ץ"

#== MAINTAINERS
MAINTAINERS="Yasuhiro MORIKAWA"

#== VERSION
PACKAGE_NAME="dcreal"
URL='http://www.gfd-dennou.org/library/cc-env/dcreal'

CVSTAGNAME='$Name: dcreal-0_3_5-3 $'
CVSDATE='$Date: 2007/02/24 02:41:32 $'
CVSREVISION='$Revision: 1.3 $'

#== USAGE
USAGE = "
      dcreal-photo.rb

      ޤ, src Ȥǥ쥯ȥ, Υǥ쥯ȥ˰ư
      . ǥץ¹Ԥ, dcreal-photo-make.rb Ȥ
      ե뤬ޤ. եԽ, src/img-web/
      ˥ǥǻä (JPG Τ) ֤,

          ruby dcreal-photo-make.rb

      ¹Ԥ, ../pub ʲ HTML ե뤬ޤ.
"

#== Acknowledgements
ACKNOWLEDGEMENTS = "
      ܥץ, Chihiro MITSUDA 
      dcphoto.pl <http://www.ep.sci.hokudai.ac.jp/~chihiro/computer/program/dcphoto/>
      , Υץ ruby Ǽ̷Ф Yukiko YAMADA 
      dcphoto-y.rb <> 򻲾Ȥƺޤ.
"
#== Bugs
BUGS= "

      * $infofile ιԿ ${file_num}*2 꾮ưޤ
"

#==COPYRIGHT 
#
COPYRIGHT =
  "Copyright (C) 2007 GFD Dennou Club"

#== History
#
#These entries is generated by CVS automatically.
#So don't add new information manually.
#(But please adjust old log format to latest log format manually,
#if format gap between them causes).
#
#$Log: dcreal-photo.rb,v $
#Revision 1.3  2007/02/24 02:41:32  morikawa
#* Ȥ ":" ưʤХ.
#* HTML  <  >  &lt;, &gt; ѹ.
#* ȥȤδ֤Ԥοѹ.
#
#Revision 1.2  2006/04/03 17:04:52  morikawa
#* jhead Τư -j, --jhead ץɲ.
#
#Revision 1.1  2006/03/30 09:32:53  morikawa
#* ߥʡͻҤ᤿̿򥵥ͥ HTML 뤿 Ruby
#  ץ.
#* dcphoto.pl (ɻ)  dcphoto-y.rb (ͳһ) 
#  , ä.
#
#
#

############################################################
## config part

IMGDIR = "./img-web"
PUBDIR = "../pub"

## config part end
############################################################


# ---------------------------------------------------------
# required libraries
require 'date'
require 'optparse'
require 'etc'
require 'kconv'
require 'pathname'
$KCODE = "e"

# ---------------------------------------------------------
# СʥС
UPDATE=CVSDATE.sub(/\s*\$\w+: /, '').sub(/\s*\$$/, '')
FILE_VERSION=CVSREVISION.sub(/\s*\$\w+: /, '').sub(/\s*\$$/, '')
pver_tmp=CVSTAGNAME.sub(/\s*\$\w+: /, '').sub(/\s*\$$/, '').sub(/#{PACKAGE_NAME}\-/, '').gsub(/_/, '.').chomp.strip
PACKAGE_VERSION = pver_tmp == "" ? '(Latest CVS version)' : pver_tmp

# ---------------------------------------------------------
# options are parsed
opt = OptionParser.new
OPTS = {}
ARGV.options{|opt|

  opt.summary_width = 23
  opt.summary_indent = ' '*6

  opt.on_tail('-j', '--jhead', 
                              "#{IMGDIR} ʲ JPG ե
                              ͡Τ߹Ԥޤ.\n"
              ){|v| OPTS[:jhead] = v}

  opt.on_tail('-h', '--help', 
                             "إפϤޤ.\n"
              ){|v| OPTS[:help] = v}

  opt.on_tail('-H', '--help-detail',
                             "Υץ˴ؤܺپϤޤ.\n"
              ){|v| OPTS[:help_detail] = v}

  opt.parse!
}
n = nil

# ---------------------------------------------------------
# help
def help(opt)
  print <<-"EOF"

  #{File.basename($0.to_s)}: #{PACKAGE_NAME} #{PACKAGE_VERSION}
    <URL: #{URL}>
    Copyright: #{COPYRIGHT}

    TITLE: #{TITLE}

    USAGE: #{USAGE}

    OPTION: \n#{opt.to_a[1..-1].join("")}
    VERSION: 
      Version: #{FILE_VERSION}, Last Update: #{UPDATE}

EOF
end
private :help

def help_detail(opt)
  help(opt)
  print <<-"EOF"

    MAINTAINERS: #{MAINTAINERS}

    ACKNOWLEDGEMENTS: #{ACKNOWLEDGEMENTS}

    BUGS: #{BUGS}

EOF
end
private :help_detail

if OPTS[:help] then
  help(opt)
  exit
end

if OPTS[:help_detail] then
  help_detail(opt)
  exit
end


# ̾Ѵ
#
# jhead ѤƲѴԤ.
def rename_images
  jhead_cmd = "jhead"
  jhead_cmd_check = "which #{jhead_cmd}"
  if !IO.popen(jhead_cmd_check).gets
    errmsg = <<-ERR


  Error : \"#{jhead_cmd}\": command not found.
          Please install \"jhead\".


ERR
    raise ArgumentError, errmsg
  end

  Dir.foreach(IMGDIR) { |file|
    next if file.to_s == ".." || file.to_s == "."
    next unless file.to_s =~ /\.jpe?g$/i
    next if file.to_s =~ /^\d{4}\-\d{2}\-\d{2}\-\d{6}\.jpg$/
    system("#{jhead_cmd} -nf%Y-%m-%d-%H%M%S #{IMGDIR}/#{file}")
  }
end
private :rename_images


if OPTS[:jhead] then
  rename_images
  exit
end

# ---------------------------------------------------------
# main()

def dcreal_photo_main
  print "#{relative_str(__FILE__, $0.to_s)} is required.\n"
  rename_images; print "rename images in #{IMGDIR} end\n"
  mkinfo       ; print "mkinfo end\n"
  makethum     ; print "mkthum end\n"
  mkminipic    ; print "makeminipic end\n"
  makehtml     ; print "makehtml end\n"
end


# ---------------------------------------------------------
# ʲ֥롼. °ղ
private

# -------------------------
#  (jpg ե̾, , ȥե)

def mkinfo

  # img-web ե̾Ȥ,  imgfiles 
  $imgfiles = []
  Dir.foreach(IMGDIR) { |item|
    $imgfiles.push(File.basename(item, ".jpg")) if item =~ /jpg$|JPG$/
  }

  # ե
  $file_num = $imgfiles.size

  $imgfiles = $imgfiles.sort

  # $infofile ʤк
  unless File.exist?($infofile) then
    ifile = open($infofile, "w")
    1.upto($file_num) { |num|
      ifile.print "%03d:\n" % num
#      ifile.print "#{$imgfiles[num]}:\n" % num
    }
    ifile.close
  end

  # $infofile ե̾ȥȤФ
  # $info[true][0] ˤϥե̾, $info[0][true] ˤϥȤ
  $info = [] 
  ifile = open($infofile, "r")
  ifile.each { |line|
    $info.push(line.chomp.split(/:/, 2))
  }
  ifile.close

  # $infofile ե
  $file_num = $info.size


end

# -------------------------
# 礭ѹ, PUBDIR سǼ.

def mkminipic

  # ǥ쥯ȥκ
  Dir.mkdir("#{PUBDIR}",0775) unless File.exist?("#{PUBDIR}") 
  Dir.mkdir("#{PUBDIR}/large",0775) unless File.exist?("#{PUBDIR}/large") 
  Dir.mkdir("#{PUBDIR}/small",0775) unless File.exist?("#{PUBDIR}/small") 

  # 礭ѹ
  $file_num.times{ |num|
    picname = $info[num][0]
    print "  #{picname}.jpg is created.\n" unless File.exist?("#{PUBDIR}/large/#{picname}.jpg")
    `convert -geometry 640x480 #{IMGDIR}/#{$imgfiles[num]}.jpg  #{PUBDIR}/large/#{picname}.jpg` unless File.exist?("#{PUBDIR}/large/#{picname}.jpg") 
    `convert -geometry 240x180 #{IMGDIR}/#{$imgfiles[num]}.jpg #{PUBDIR}/small/#{picname}.jpg` unless File.exist?("#{PUBDIR}/small/#{picname}.jpg") 
#    `convert -geometry 100x75 #{IMGDIR}/#{$imgfiles[num]}.jpg #{PUBDIR}/small/#{picname}.jpg` unless File.exist?("#{PUBDIR}/small/#{picname}.jpg") 
  }
end


# -------------------------
# ͥ $index κ

def makethum

  # ǥ쥯ȥ, ե
  if File.exist?("#{PUBDIR}") then
    Dir.foreach("#{PUBDIR}") { |item|
      File.delete("#{PUBDIR}/" + item  ) if item =~ /.html$/
    }
  elsif
    Dir.mkdir("#{PUBDIR}",0775) 
  end
  
  # $index ڡη׻
  if ($file_num % 18 ) == 0 then
    $thum_max =  $file_num /18 
  else
    $thum_max = ($file_num / 18) + 1
  end

  # $index եʥС
  $thum_num = 1

  $file_num.times { |num|
    if (num % 18) == 0 then
      # 
      $htmls = ""
      # إå
      $htmls = htmlhead
      # ʸɽ
      $htmls << htmltitle
      # $index ڡ
      unless ($file_num / 18) == 0 then 
	$htmls << htmlpage($thum_num) unless $file_num  == 18 
      end
    end

    # ͥʬ 
    $htmls << htmlthum(num)

    if (num % 18) == 17 then
      # $index ڡ
      unless $file_num  == 18 then
	$htmls << htmlpage($thum_num)
      end
      # եå
      $htmls << htmlfoot
      # եν񤭤
      ifile = open("#{PUBDIR}/" + $index + $thum_num.to_s + ".html", "w")
      ifile.print $htmls
      ifile.close
      $thum_num += 1
    end
  }

  unless ($file_num % 18 ) == 0 then
    # table 
    amari = ($file_num - 1 ) % 3
    amari.upto(1) { |num|
      $htmls << <<HTMLEOF
       <td align="center" width="20%" valign="top">
        &nbsp;
       </td>
HTMLEOF
    }
    $htmls << %|      </tr>\n| unless amari == 2

    # $index ڡ
      unless ($file_num / 18) == 0 then 
	$htmls << htmlpage($thum_num)
      end
    # եå
    $htmls << htmlfoot

    # եν񤭤
    ifile = open("#{PUBDIR}/" + $index + $thum_num.to_s + ".html", "w")
    ifile.print $htmls
    ifile.close
  end 

  # ե̾ѹ ${index} + "0.html" => ${index}".html"
  File.rename("#{PUBDIR}/" + $index + "1.html","#{PUBDIR}/" + $index + ".html" )

end


# -------------------------
#  HTML ե֥롼
def makehtml

  # ǥ쥯ȥ, ե
  if File.exist?("#{PUBDIR}/html") then
    Dir.foreach("#{PUBDIR}/html") { |item|
      File.delete("#{PUBDIR}/html/" + item  ) if item =~ /html$/
    }
  elsif
    Dir.mkdir("#{PUBDIR}/html",0775) 
  end

  # ե
  $file_num.times { |num|
    htmldetail(num)
  }
end

def htmldetail(num)

  prepic    = $info[num-1][0]  unless num == 0 
  picname   = $info[num][0]
  nextpic   = $info[num+1][0]  unless num == ( $file_num - 1 )
  comment   = $info[num][1] || ""
  
  # ɸ 
  print "  #{num+1}: comment = #{comment}\n"

  htmls = ""
  htmls = htmlhead
  htmls << <<HTMLEOF
<body>
<center>
<table><tr><td align="center">
HTMLEOF

  # ŽĤʬ, եåκ
  htmls << <<HTMLEOF
<img src="../large/#{picname}.jpg" >
<br>
#{comment}<br>
[ #{phototime(picname)}  ]
<br>&nbsp;
</td></tr></table>
HTMLEOF

  # ΥڡؤΥ, ڡ/ڡ, ν񤭽Ф
  htmls << <<HTMLEOF
<table width="80%">
  <tr>
  <td bgcolor="#{$color_table}" align="center">
HTMLEOF

  # ǽΥڡȺǸڡξϥ󥯤ŽʤΤ
  # ʬ.
  
  # ǽΥڡ [] ˥󥯤Žʤ
  if num == 0 then 
    htmls << %|      [ PRE ] &nbsp;&nbsp; |
  else
    htmls << %|      [ <A HREF="./#{prepic}.html">PRE</A> ] &nbsp;&nbsp;|
  end
  
  # 󥯤Ϥ٤ $index ξ׻
  if (num / 18) == 0 then 
    htmls << %|      [ <A HREF="../#{$index}.html">index</A> ] &nbsp;&nbsp;|
  else
    htmls << <<HTMLEOF 
     [ <A HREF="../#{$index}#{(num/18)+1}.html">index</A> ] &nbsp;&nbsp; 
HTMLEOF
  end

  # ǸΥڡ [] ˥󥯤Žʤ
  if num ==  ( $file_num - 1 ) then 
    htmls << %|      [ NEXT ]|
  else
    htmls << %|      [ <A HREF="./#{nextpic}.html"> NEXT </A>]|
  end

  # եå
  htmls << <<HTMLEOF
    </td>
  </tr>
</table>
</td></tr></table>
</center>
</body>
</html>
HTMLEOF

  # եν񤭤
  ifile = open("#{PUBDIR}/html/" + picname + ".html", "w")
  ifile.print htmls
  ifile.close
end



#-------------------------------------------------------------
# ͥ $index ѥ֥롼

# html إå
def htmlhead
   htmls = <<HTMLEOF
<html lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=x-euc-jp">
  <meta name="Author" content="#{username_from_gid}">
  <meta name="robots" content="noindex,nofollow">
  <meta name="robots" content="noarchive">
  <meta name="generator" content="#{File.basename(__FILE__)} ver #{FILE_VERSION} in #{PACKAGE_NAME} #{PACKAGE_VERSION} released in #{URL}">
  <title>#{$title}</title>
  <style type="text/css">
  <!--
    BODY { font-style:osaka;color:#{$color_font};}
    a:link { color:#{$color_link}; }
    a:visited { color:#{$color_visited}; }
    A{text-decoration:none; font-weight:bold; }
    A:hover {color:#{$color_hover}}
  -->
  </STYLE>
</head>
HTMLEOF
return htmls
end

# html thumnail ֤
def htmlthum(num)
  picname = $info[num][0]
  amari   = num % 3
  comment = $info[num][1]

  # ơ֥֤ˤä <tr> ΤĤ򤪤ʤ.
  # ü : 3n+1   ($amari == 0)
  # ü : 3n     ($amari == 2)

  htmls = ""
  htmls = %|      <tr align="center" VALIGN="bottom">\n| if amari == 0
  htmls << <<HTMLEOF    
       <td align="center" width="20%" valign="top">
         <A HREF="./html/#{picname}.html">
         <img src="./small/#{picname}.jpg" border="0">
        </A>
        <br>
        <small>
         #{comment}
        </small>
       </td>
HTMLEOF

  htmls << %|      </tr>\n| if amari == 2
  return htmls
end

# եå
def htmlfoot
  htmls = <<HTMLEOF    
<tr><td colspan="3" bgcolor="#{$color_table}" align="center">
<B><small>#{$footer}</small></B>
</td></tr>

</table>

 </center>
 </body>
</html>
HTMLEOF
  return htmls
end

# ʸɽ
def htmltitle
  htmls = <<HTMLEOF
 <body>
  <center>
<table BORDER="0" cellspacing="10" width="80%" align="center">
<tr><td colspan="3" bgcolor="#{$color_table}" align="center">
&nbsp;
<br>
<B><big>&lt;&lt; #{$header1} &gt;&gt;</B></big><br>
<small>#{$header2}</small>
<br>&nbsp;
</td></tr>
HTMLEOF
return htmls
end

# ͥؤΥ
def htmlpage(num)
  htmls = <<HTMLEOF
<tr><td colspan="3" align="center"><small>
HTMLEOF
  1.upto($thum_max){ |numnum|
  # ʬˤϥ󥯤Žʤ
  if numnum == num then 
    htmls << %| &nbsp; [ PAGE#{numnum} ] |
  else
    if numnum == 1 then 
      htmls << <<HTMLEOF
&nbsp; [ <A HREF="./#{$index}.html">PAGE#{numnum}</A> ] 
HTMLEOF
    else
      htmls << <<HTMLEOF
&nbsp; [ <A HREF="./#{$index}#{numnum}.html">PAGE#{numnum}</A> ] 
HTMLEOF
    end
  end
  }
  htmls << %| &nbsp; </small></td></tr>\n|
return htmls
end

# λμ
def phototime(picname)
  test = `jhead #{PUBDIR}/large/#{picname}.jpg`
  hoge = ""
  test.split(/\n/).size.times { |num|
    hoge = test.split(/\n/)[num]  if test.split(/\n/)[num] =~ /Date/
  }
  return hoge.split(/    : /)[1]
end

#
#  uid б桼̾ (̾) ֤
# uid  nil Ϳϥץ uid б桼̾ (̾)
# ֤uid ̵ʤΤǤ硢顼֤
#
def username_from_uid(uid=nil)
  unless uid
    pw = Etc.getpwuid(Process.uid) or return nil
  else
    pw = Etc.getpwuid(uid) or return nil
  end
  
  user_name = pw.name
  return user_name
end

#
#  gid б桼̾ (̾) ֤
# gid  nil Ϳϥץ gid б桼̾ (̾)
# ֤gid ̵ʤΤǤ硢顼֤
#
def username_from_gid(gid=nil)
  unless gid
    pw = Etc.getpwuid(Process.gid) or return nil
  else
    pw = Etc.getpwuid(gid) or return nil
  end
  
  user_name = pw.name
  return user_name
end

#
# target Ϳ줿ѥ (String ֥)  from (String 
# ֥) 鸫ХѥȤ String ֥Ȥ֤
#  Pathname 饹ѤƤ롣
# ͿѥХѥǤХѥǤ⤫ޤʤ
#
def relative_str(target=nil, from=nil)
  return nil    unless str_and_notspace?(target)
  return target unless str_and_notspace?(from)
  
  from_dir     = File.dirname(from)
  target_dir   = File.dirname(target)
  target_base  = File.basename(target)
  
  from_ab_path   = Pathname.new(File.expand_path(from_dir))
  target_ab_path = Pathname.new(File.expand_path(target_dir))
  
  target_re_path = target_ab_path.relative_path_from(from_ab_path)
  
  result = target_re_path.to_s + "/" + target_base
  
  return result
end

#
# 줿ѿʸǡĶʸΤߤǤϤʤȤ
# Ĵ٤᥽åɡܸǤäƤ⡢ʸäƤ true ֤
#
def str_and_notspace?(obj)
  
  if !obj.instance_of?(String) then
    return false
  end
  
  # ܸʸбǤ褦
  Kconv::toeuc(obj)
  
  if /\S+/e =~ obj.chomp.strip then
    return true
  else
    return false
  end
end



######################################################
if $0 == __FILE__

dcreal_photo = <<EOF
#!/usr/bin/env ruby
#
#= dcreal-photo configure file
#
#  Editor :: #{username_from_uid}
#  Created:: #{Time.now.strftime("%Y/%m/%d %H:%M:%S")}
#
#== Overview
#
#This file is generate by following ruby script automatically.
#
#      #{File.expand_path($0.to_s)}
#      version "#{FILE_VERSION}"
#
#Please edit this file according to your purpose.
#
########################################################
##  ǥե, 桼
########################################################

# ե
$infofile = "comment.txt"

# ǥåե (ĥҤ $index + ".html")
$index = "index"

# ơ֥, եȤο
$color_table   = "#ADD8E6" 
$color_font    = "#000080" 
$color_link    = "#269900" 
$color_visited = "#269900" 
$color_hover   = "#99FF33" 

# html إåȥ
$title  = "GFD Seminar #{Time.now.strftime("%Y")}"
\#$title  = "FDEPS #{Time.now.strftime("%Y")}"
\#$title  = "ݳع #{Time.now.strftime("%Y")}"

# ͥ륿ȥ
$header1 = $title
$header2 = "#{Time.now.strftime("%Y/%m/%d")}--?? at Hokkaido Univ.";

# ͥեå ;
$footer = "Last update: \#\{Time.now\} <br> 
           #{COPYRIGHT}"

# ---------------------------------------------------------
# ȥǥ쥯ȥѿˤ錄.
require "#{File.expand_path($0.to_s)}"

# ---------------------------------------------------------
# main()

dcreal_photo_main

EOF

sample_file = "./dcreal-photo-make.rb"
existing_file = File.exist?(sample_file)
wfile = open(sample_file,"w")
wfile.print dcreal_photo
wfile.close

if existing_file
  print "\n  *** MESSAGE *** #{sample_file} is overwritten.\n"
else
  print "\n  *** MESSAGE *** #{sample_file} is created.\n"
end

print <<-"EOF"

  *** GUIDANCE *** 
  Please edit "#{sample_file}", and locate JPG files in "#{IMGDIR}".
  Then do 

    ruby #{sample_file}

  In the result, HTML files are generated in "#{PUBDIR}"

  If you want to know more information, add "-h" option.

EOF

end
